// The module 'vscode' contains the VS Code extensibility API
// Import the module and reference it with the alias vscode in your code below
const { workspace } = require('vscode');
const vscode = require('vscode');

// this method is called when your extension is activated
// your extension is activated the very first time the command is executed

/**
 * 
 *
 */

function activate(context) {


	// The command has been defined in the package.json file
	// Now provide the implementation of the command with  registerCommand
	// The commandId parameter must match the command field in package.json
	let disposable = vscode.commands.registerCommand('extension.linkcode', function (path) {
		// The code you place here will be executed every time your command is executed

			
		if (typeof path === 'undefined') 
		{
			const editor = vscode.window.activeTextEditor;
			const resource = editor.document.uri;
			if (resource.scheme === 'file')
			{		
				
				if (typeof editor === 'undefined') 
				{
					msg('当前文件不能获取。');
				}
				else
				{
					path = vscode.window.activeTextEditor.document.uri.path;
					var nowpath = path.slice(1);
					//msg(nowpath);
					mklinkcode(nowpath);
				}

			} 					
			else
			{
				
				msg('当前文件为空。');
			}
				
		}
		else
		{
			var str = path.toString();
			var ss = str.slice(8);
			var spath= ss.slice(4);
			var spfu = ss.slice(0,1);
			str = spfu+':'+spath;
			//msg(nowpath);

			mklinkcode(str);
		}

	});

	context.subscriptions.push(disposable);
}

function msg(str)
{
	vscode.window.showInformationMessage(str);
}


function mklinkcode(nowpath)
{
	//mklink 命令
	var execmd ='mklink '+ nowpath+' D:/Users/Administrator/AppData';
	msg(execmd);
	//var test = 'fsutil file createnew d:/txt1.txt 0';
	require('child_process').execSync(execmd);
}
/*原始代码
function linkcode(nowpath)
{
	const rootHost='d:/root'
	const rootDir ='.linkcode'
	const rootPath = path.join(rootHost,rootDir)
	const filename:false | string = path.filename(nowpath)
	if(nowpath.indexOf(rootHost) === -1)
	{
		return msg('error 越界了')
	}
	else if(nowpath.indexOf(rootPath) === 0)
	{
		return msg('error 这里是已归档');
	}
	else
	{
		const confignowlist:string[] = path.reddir(rootPath)
		confignowlist.push(rootDir)
		if(confignowlist.indexOf(nowname))
		{
			return msg('error 已存在')
		}
		else
		{
			const cmd = filename ? '/h' :'/d'
			//执行 mklink cmd path.join(rootPath,nowname) nowpath
			
			return msg('success'+ nowname)
		}
	}

}
*/
// this method is called when your extension is deactivated
function deactivate() {}

exports.activate = activate;
exports.deactivate = deactivate;
